open Generator
open Entropy
open Tree
  
let main() =
  Gc.set { (Gc.get()) with Gc.stack_limit = 1024*1024 } ;
  let n = int_of_string (Sys.argv.(1))
  and p = float_of_string (Sys.argv.(2)) in
  let tests = generate_tests (n/2) n in
  let proba = generate_probabilities p n in
  let t = build_tree proba tests in
  print_string "entropy (base 3) : ";
  print_float (entropy proba);
  print_newline ();
  print_string "mean depth       : ";
  print_float (mean_depth t proba);
  print_newline ();
  print_string "max depth        : ";
  print_int (depth t);
  print_newline ();
  show_tree t n;
  ;;

main ();;
  
