open Generator

type test = {
    weighing : weighing;
    mutable entropy : float;
  }

type result =
  | Left
  | Right
  | Equilibrium
      
(* cre tous les tests possibles avec card pices <= max_coin *)      
val generate_tests : int -> int -> test list
    
(* gnre la distribution de probabilits initiale *)
(* p0 vaut all_true et les autres sont uniformes *)
val generate_probabilities : float -> int -> float array

(* trouve le test avec la plus petite entropie dans la liste *)
val find_min_entropy_test : test list -> test option -> test option

(* renvoie les probabilits des rsultats d'une pese sous la forme *)
(* p(gauche),p(droite),p(quilibre) *)
val probabilities : test -> float array -> float*float*float

(* calcule l'entropie associe  une distribution de probabilit *)  
val entropy : float array -> float

(* renvoie la distribution de probabilits conditionnelles si test aboutit *)
(* au rsultat hypothese *)
val learn : test -> result -> float array -> float array
    
(* met  jour le champ entropy de tous les tests *)
val update_all_tests : float array -> test list -> unit
